




        subroutine INVCARTES(rhst,GM,AEIOWM)

!!! This subroutine does NOT work !!!!!! DWM 5-feb-92
! problem with finding semi-axis, etc....

! given:
!        GM -product of G and Earth mass 
!        r(3) - position vector of spacecraft wrt earth
!        v(3) - velocity vector of spacecraft wrt earth
! return:
!        AEIOWM(6) Orbital elements of spacecraft wrt earth
!
! DWM 5-feb-92
! method from Fundamentals of Astrodynamics pg. 61-64
!             Bate, Mueller and White (1971 Dover) 

	implicit none

	double precision r(3),v(3),GM,AEIOWM(6),esize,E1
	double precision rsize,vsize,dp,ang,rv,hsize,nsize
	double precision h(3),n(3),e(3),k(3),nu,pi,rhst(6)
	integer i

        pi=3.141592653589793d0

	r(1)=rhst(1)
	r(2)=rhst(2)
	r(3)=rhst(3)
	v(1)=rhst(4)
	v(2)=rhst(5)
	v(3)=rhst(6)

	k(1)=0.0d0
	k(2)=0.0d0
	k(3)=1.0d0

	call VECP(r,v,h)
	call VECP(k,h,n)

	Call DOTP(r,r,rsize,ang)
	 rsize=dsqrt(rsize)
	Call DOTP(v,v,vsize,ang)
	 vsize=dsqrt(vsize)
	Call DOTP(h,h,hsize,ang)
	 hsize=dsqrt(hsize)
	Call DOTP(n,n,nsize,ang)
	 nsize=dsqrt(nsize)

	call DOTP(r,v,rv,ang)

	do i=1,3
	 e(i)=(1/GM)*(((vsize**2)-(GM/rsize))*r(i)-rv*v(i))
	end do

	Call DOTP(e,e,esize,ang)
	 esize=dsqrt(esize)

	 AEIOWM(1)=(hsize**2)/GM
	 AEIOWM(2)=esize
	 AEIOWM(3)=DACOS(h(3)/hsize)
	 AEIOWM(4)=DACOS(n(1)/nsize)

	if(n(2).gt.0.0d0) AEIOWM(4)=-AEIOWM(4)

	 call DOTP(n,e,dp,ang)

	 AEIOWM(5)=DACOS(dp/(nsize*esize))

	if(e(3).gt.0.0d0) AEIOWM(5)=-AEIOWM(5)

	 call DOTP(n,r,dp,ang)

	 nu=DACOS(dp/(nsize*rsize))

	E1 = 2.0d0*
     1  DATAN(DSQRT((1.0d0-esize)/(1.0d0+esize))*DTAN(nu/2.0))


	if(E1.lt.0.0d0)   E1 = pi + E1 
 
	if(r(3).gt.0.0d0) E1 = -E1

	AEIOWM(6) = E1 - esize*DSIN(E1)

	return 
        end
