      	 subroutine plotyz(filename,plotf,LINEWD,NDOTSZ,
     1     x1vp,x2vp,y1vp,y2vp,frac)

! change from interactive program to subroutine call
! DWM 26-Jul-93
	
      	real x(10000),y(10000)
 	real x1vp,x2vp,y1vp,y2vp,frac
	character filename*19,plotf*80,xlabel*80
	integer LINEWD,NDOTSZ

       character xlab1*4,xlab2*3,xlab3*2,xlab4*2,xlab5*2

!	x1 = 0.1
!	x2 = 0.9
!	y1 = 0.1
!	y2 = 0.9

 	x1 = 0.0
 	x2 = 1.0
 	y1 = 0.0
 	y2 = 1.0



	inum_max=10000


         iblack =0  
         iwhite =1  
         ired   =2
         igreen =3
         iblue  =4
         icyan  =5
         iyellow=7
         iorange=8
         iredmagenta=13
         idkgrey=14
         iltgrey=15

!	 write(*,*) 'filename:'
!	 write(*,'(a)') filename


!	write(*,*) 'What file contains yz-angle information ?'
!	write(*,*) '(usually yzplot.dat)'
!	read(*,'(a)') filename

	open(10,file=filename,status='old')

	read(10,*) IYREF,IDREF,IHREF,IMREF,ISREF
!	write(*,*) IYREF,IDREF,IHREF,IMREF,ISREF

	write(xlab1,'(i4)') IYREF
	write(xlab2,'(i3)') IDREF
	write(xlab3,'(i2)') IHREF
	write(xlab4,'(i2)') IMREF
	write(xlab5,'(i2)') ISREF

!	xlabel='TIME (hr) FROM REF EPOCH ('//xlab1//' day '//xlab2//
!     1  ' '//xlab3//':'//xlab4//':'//xlab5//')'

	xlabel ='Time (hours) from 0 UT on  day '//xlab2//
     1  ' of '//xlab1

	time1=float(IDREF)+float(IHREF)/24.0+float(IMREF)/1440.0
     1          +float(ISREF)/86400.0 

	time0=float(IDREF)

	dtime=24.0*(time1-time0)



	read(10,*) t1,t2,dt

	t1 = t1 + dtime
	t2 = t2 + dtime
	
	read(10,*) yzmin,yzmax,dyz

!	yzmin=yzmin-0.5*dyz
!	yzmax=yzmax+0.5*dyz

	tmin=t1 -0.5*dt
	tmax=t2 +0.5*dt

	inum=0

	do i=1,inum_max
	 read(10,*,end=100) t,yz
	 inum=inum+1
	 x(inum)=t+dtime
	 y(inum)=yz
!	 write(*,*) i,x(i),y(i)
	end do

100	continue

!	call pgbegin(0,plotf,1,1)
	CALL PGSLW(LINEWD)
	call pgbbuf

	call pgsci(iyellow)

!	call pgenv(tmin,tmax,yzmin,yzmax,0,2)

!	call pgvport(0.1,0.9,0.1,0.9)
	call pgvport3(x1,x2,y1,y2,x1vp,x2vp,y1vp,y2vp,frac)
	call pgwindow(tmin,tmax,yzmin,yzmax)
	call pgbox('ABCGNST',0.0,0,'ABCGNST',0.0,0)

	call pglabel(xlabel,'yz rotation angle (\uo\d)'
     1  ,'Allowed yz rotation angles')

	call pgsci(iyellow)
	call pgmove(tmin,180.0)
	call pgdraw(tmax,180.0)

	call pgsci(igreen)

	do i=1,inum
c	 x1=x(i)-0.5*dt
c	 x2=x(i)+0.5*dt
c	 y1=y(i)-0.5*dyz
c	 y2=y(i)+0.5*dyz
	 x1=x(i)-dt
	 x2=x(i)+dt
	 y1=y(i)-dyz
	 y2=y(i)+dyz	 
	 if (y(i).eq.5.or.y(i).eq.355) 	 call pgrect(x1,x2,y1,y2)
!	 write(*,*) i,x1,x2,y1,y2
	end do

!	call pgsci(ired)
!	call pgpoint(inum,x,y,2)

!	call pgsci(iyellow)
!	call pgmove(tmin,180.0)
!	call pgdraw(tmax,180.0)

!	call pgsci(iyellow)
!	call pgmove(tmin,0.0)
!	call pgdraw(tmax,0.0)



	call pgebuf
!	call pgend

!	write(*,*) 'plot on another graphics device ? (1=yes)'
!	read(*,*) ians

	ians = 0

	if(ians.eq.1) goto 100

	return
	end

	

